/*
NAME: 
DESCRIPTION: ;
PARAMETER:
    [
		{
			name : 'ring_size',
			title : 'ring大小',
			type : 'IntLineEdit',
			property : {tool_tip : 'ring大小'},
		},
		{
			name : 'line_size',
			title : '优化线径值',
			type : 'IntLineEdit',
			property : {tool_tip : '优化线径值'},
		},
		{
			name : 'step_fliter',
			title : 'Step过滤',
			type : 'LineEdit',
			property : {tool_tip : 'unit'},
		},
		{
            name : 'auto_save',
			title : '自动保存',
            type : 'RadioBox',
            property : {
				item_list:[
					{name:'yes',text:'YES'},
					{name:'no',text:'NO'},
				],
				tool_tip:'是否自动保存料号开关'
			}
        }
	]
	
 VERSION_HISTORY:
	V1.00 2020-04-28 Scott Sun
	    1.新版本
		
 HELP:
 	<html><body bgcolor="#DDECFE">
		<font size="3" color="#003DB2"><p>功能简介</p></font>
		<p> 隔离环优化 </p>
		<br>
		<font size="3" color="#003DB2"><p>参数配置</p></font>
		<p> 配置 </p>
		<br>
		<font size="3" color="#003DB2"><p>注意事项</p></font>
		<p> 无 </p>
		<br>
	</body></html>	
*/
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
console.log("==============================>JTG_INN_neg_isolation_pad_optimization_aim");
/* question
    ?
*/
// 引入模块 包
var $ = require('topcam.scriptfunc').argv();
var fs = require('fs');
const { padStart } = require('lodash');
var _ = require('lodash');
var mode = $.ikm ? "topcam" : "aimdfm";
var IKM = $.ikm; 
if (IKM==undefined ) { IKM = require('topcam.ikm6')($) }
var GEN = $.gen;
var GUI = $.gui || {};
var Job = $.job || $.job_name;
var JobId = $.job_id;
var db = $.db || IKM.db;
var PAR = {}
if ($.par) {
	PAR = $.par
} else if ($.hasOwnProperty('script_parameter')){
	PAR = JSON.parse($.script_parameter);
}
if (mode === "aimdfm") {
	var database = require("topsin.database");
	database.addConnection($.conf.database_conf, "DFM");
	var QDfm = database.query("DFM");
	$.QDfm = QDfm;
	if ($.conf.product_type == "aimdfm") {
		QDfm.updateRow({
			table: "pdm_aimdfm_task",
			data: {
				current_process_title: $.process_title
			},
			where: { id: $.task_id }
		});
	}
}
var Status = 'ok';
var resultData = [];

try {
    var par = PAR;
    var default_par = {  // par默认参数？
        step_fliter:"unit",
		units: "mm",
        auto_save: "no",
        ring_size:200,
        line_size:200
	}
	for(var key in default_par){  // 设置默认属性
		if (!par.hasOwnProperty(key) || par[key] == ""){
			par[key] = default_par[key]
		}
	}
	var par_props = ["ring_size","line_size"]   // par的必填参数
	par_props.forEach(function(v){
		if(par[v] == ""){throw "par props "+v+" err"}
	})
	if(_.isEmpty(Job)){throw "参数Job不存在"}
    var job = Job.toLowerCase()
    // 料号验证
	if(!GEN.isJobExists({job:job})){throw "料号"+job+"不存在"}
	if(!GEN.isJobOpen({job:job})){ GEN.openJob({job:job}) }
	if(mode == "aimdfm"){
        if(GEN.checkInout({job:job,mode:"test"}) != 0){ throw "the job check" }
        GEN.checkInout({job:job,mode:"out"});
    }
	// 脚本开始

	var stepList = GEN.getStepList({job:job})
	if(par.step_fliter != ""){
		var step_reg = new RegExp(par.step_fliter) 
		stepList = stepList.filter(function(v){return step_reg.test(v)})
	}
	// 通过matrix中选择属性为negative&power_ground&inner的内层负片层
	var matrix = GEN.getMatrix({job:job})
	var n_layers = Object.keys(matrix).sort(function(a,b){return matrix[a].row - matrix[b].row})
	.filter(function(key){
		var val = matrix[key]
		return val.layer_type == "power_ground" && val.polarity == "negative" && val.side == "inner" && val.context == "board"
	})
	if(n_layers.length == 0){throw "can not find power_ground negative layer"}
	var tmp1 = "tmp_1", tmp2 = "tmp_2"
	var tmp_layers = [tmp1,tmp2];
	stepList.forEach(function(step){
		GEN.openStep({job:job, name:step})
		GEN.units({type:par.units})
		GEN.affectedLayer({affected:'no',mode:'all'})
		GEN.clearLayers()
		n_layers.forEach(function(layer){
			// 逐层制作，过滤选出 rect*,r*,s*,oval 属性的物件并移动到辅助层1；
			tmp_layers.forEach(function(v){
				if(GEN.isLayerExists({job:job,layer:v})){GEN.deleteLayer({job:job, layer:v})}
				GEN.createLayer({job:job, layer:v})
			})
			GEN.workLayer({name:layer,display_number:2,clear_before:'yes'})
			GEN.selectByFilter({include_syms:"rect*;r*;s*;oval*"})
			if(GEN.getSelectCount()>0){ 
                GEN.selMoveOther({target_layer:tmp1,invert:'no',dx:0,dy:0,size:0})
				// 复制辅助层1至辅助层2，将辅助层1上的物件修改为r1.2；
				GEN.workLayer({name:tmp1,display_number:2,clear_before:'yes'})
				GEN.selAllFeat()
				GEN.selCopyOther({dest:'layer_name',target_layer:tmp2,invert:'no',dx:0,dy:0,size:0})
                GEN.selChangeSym({symbol:"r1.2"})
				// 使用参考选择reference select命令touch辅助层1，筛选出drl层上有隔离焊盘的孔；
                GEN.workLayer({name:"drl",display_number:2,clear_before:'yes'})
                if(!GEN.isLayerExists({job:job, layer:"pth"})){
                    GEN.selectByFilter({attribute:[{attribute:'.drill',option:'plated'}]})
                    if(GEN.getSelectCount() > 0) {GEN.selCopyOther({dest:'layer_name',target_layer:'pth',invert:'no',dx:0,dy:0,size:0})}
                }
                if(!GEN.isLayerExists({job:job, layer:"np"})){
                    GEN.selectByFilter({attribute:[{attribute:'.drill',option:'non_plated'}]})
                    if(GEN.getSelectCount() > 0) {GEN.selCopyOther({dest:'layer_name',target_layer:'np',invert:'no',dx:0,dy:0,size:0})}
                }

                if(GEN.isLayerExists({job:job, layer:"pth"})){
                    GEN.workLayer({name:"pth",display_number:2,clear_before:'yes'})
                    GEN.selRefFeat({layers:tmp1,use:'filter',mode:'touch'})
                    // copy这些选中的孔到辅助层2，resize设置为400um；  par.ring_size
                    if(GEN.getSelectCount()>0){ 
                        GEN.selCopyOther({dest:'layer_name',target_layer:tmp2,invert:'no',dx:0,dy:0,size:par.ring_size}) 
                    }
                }
                if(GEN.isLayerExists({job:job, layer:"np"})){
                    GEN.workLayer({name:"np",display_number:2,clear_before:'yes'})
                    GEN.selRefFeat({layers:tmp1,use:'filter',mode:'touch'})
                    // copy这些选中的孔到辅助层2，resize设置为400um；  par.ring_size
                    if(GEN.getSelectCount()>0){ 
                        GEN.selCopyOther({dest:'layer_name',target_layer:tmp2,invert:'no',dx:0,dy:0,size:par.ring_size + 50}) 
                    }
                }
                GEN.workLayer({name:tmp2,display_number:2,clear_before:'yes'})
                var del_layer = tmp2 + "+++"
                GEN.runSingleDfm({
                    chklist: 'valor_dfm_nfpr',
                    params: {
                        pp_layer: tmp2,
                        pp_delete: 'Duplicate',
                        pp_work: 'Features',
                        pp_drill: 'PTH\;NPTH\;Via',
                        pp_remove_mark: 'Remove'
                    }
                })
                GEN.deleteLayer({job:job,layer:del_layer})
                // 将辅助层2上的物件move至对应的内层负片层
                GEN.workLayer({name:tmp2,display_number:2,clear_before:'yes'})
                GEN.selAllFeat()
                GEN.selCopyOther({dest:'layer_name',target_layer:layer,invert:'no',dx:0,dy:0,size:0})
            }
		})
	})
    GEN.deleteLayer({job:job, layer:tmp_layers})

	// 逐层分析内层负片层的物件，如存在小于200um的线，则将线宽优化至200um。  par.line_size
	stepList.forEach(function(step){
		GEN.openStep({job:job, name:step})
		GEN.affectedLayer({affected:'no',mode:'all'})
		GEN.clearLayers()
		GEN.selClearFeature()
		n_layers.forEach(function(layer){
			GEN.workLayer({name:layer,display_number:2,clear_before:'yes'})
			var syms = GEN.getLayerSymsHist({job:job,step:step,layer:layer})
			var change_syms = []
			for(var key in syms){
				var v = syms[key]
				if(v.size && v.size < par.line_size){
					change_syms.push(key)
				}
			}
			GEN.selectByFilter({feat_types:"line", include_syms:change_syms.join(";")})
			if(GEN.getSelectCount()>0){GEN.selDelete()}
		})
		GEN.closeStep()
	})
    GEN.deleteLayer({job:job, layer:tmp_layers})

	// 保存 
	if(/yes/ig.test(par.auto_save)){
		GEN.checkInout({job:job,mode:"out"})  // 结束保存料号 关闭料号
		GEN.saveJob({ job: job });
		GEN.checkInout({job:job,mode:"in"})
		GEN.closeJob({job:job})
	} else {
		GEN.checkInout({job:job,mode:"in"})
	}
    console.log("======================== JTG_INN_neg_isolation_pad_optimization_aim end");
    if (mode === "aimdfm") {
		$.QDfm.updateRow({
			table: "pdm_aimdfm_task",
			data: {
				progress: 33.33
			},
			where: { id: $.task_id }
		});
		if (GEN.hasError()) {
			Status = 'error';
			resultData.push({ type: "error", title: "GEN错误!", detail: [{ desc: _.join(GEN.STATUS, "\n") }] });
			return {
				status: Status,
				result_data: resultData
			};
		} else {
			resultData.push({ type: "info", title: "操作完成, 请注意检查!" });
			return {
				status: Status,
				result_data: resultData
			};
		}
	}else {
		return "Done"
	}
} catch (e) {
	IKM.msg(_.join(GEN.STATUS, "\n"))
	IKM.msg(e)
    Status = 'error';
    resultData.push({type: "error", title: "脚本执行出错!", detail: [{desc: _.toString(e)}]});
	return (mode === "aimdfm") ? {status: Status, result_data: resultData} : "Error";
}